<template>
  <div>
    <base-annotated-submission>
      <template #header>
        <annotated-submission-top-toolbar
          v-model="mathIsRendered"
          :of-student="submissionObj && submissionObj.ofStudent"
          :show-clipboard="true"
          :show-correction-help="true"
          :source-code-available="sourceCodeAvailable"
          :submission="submission"
          :submission-type="submission.type"
          :feedback="feedback"
          :is-markdown="isMarkdown"
        />
      </template>
      <template
        id="sub-lines"
        #table-content
      >
        <tr
          v-for="(code, lineNo) in submission"
          :id="`sub-line-${lineNo}`"
          :key="`${submissionObj.pk}${lineNo}`"
        >
          <math-renderer :enabled="mathIsRendered">
            <submission-line
              :hint="hasHiddenComment(lineNo)"
              :code="code"
              :line-no="lineNo"
              @toggleEditor="toggleEditorOnLine(lineNo)"
            >
              <template v-if="showFeedback">
                <div v-if="origFeedback[lineNo]">
                  <feedback-comment
                    v-for="(comment, index) in getSortedComments(lineNo)"
                    :key="index"
                    v-bind="comment"
                    :visible-to-student-bool="updatedFeedback[lineNo] ? false : comment.visibleToStudent"
                    :line-no="lineNo"
                    :deletable="comment.ofTutor === user || isReviewer"
                    @click.native="toggleEditorOnLine(lineNo, comment)"
                  />
                </div>
                <feedback-comment
                  v-if="updatedFeedback[lineNo]"
                  v-bind="updatedFeedback[lineNo]"
                  :line-no="lineNo"
                  :deletable="true"
                  @click.native="toggleEditorOnLine(lineNo, updatedFeedback[lineNo])"
                />
              </template>
              <comment-form
                v-if="showEditorOnLine[lineNo]"
                :feedback="selectedComment[lineNo].text"
                :line-no="lineNo"
                @collapseFeedbackForm="toggleEditorOnLine(lineNo)"
              />
            </submission-line>
          </math-renderer>
        </tr>
      </template>
      <template #labels>
        <label-selector
          id="feedback-label-selector"
          :assigned-to-feedback="true"
          class="mt-1 elevation-1"
        />
      </template>
      <template #footer>
        <annotated-submission-bottom-toolbar
          class="mt-1 elevation-1"
          :loading="loading"
          :full-score="submissionObj['fullScore']"
          :skippable="assignment !== undefined"
          :feedback="feedbackObj ? feedbackObj : {}"
          @submitFeedback="submitFeedback"
        />
      </template>
    </base-annotated-submission>
  </div>
</template>

<script>
import { mapState, mapGetters } from 'vuex'
import CommentForm from '@/components/submission_notes/base/CommentForm.vue'
import FeedbackComment from '@/components/submission_notes/base/FeedbackComment.vue'
import AnnotatedSubmissionTopToolbar from '@/components/submission_notes/toolbars/AnnotatedSubmissionTopToolbar'
import AnnotatedSubmissionBottomToolbar from '@/components/submission_notes/toolbars/AnnotatedSubmissionBottomToolbar'
import BaseAnnotatedSubmission from '@/components/submission_notes/base/BaseAnnotatedSubmission'
import FeedbackLabel from '@/components/feedback_labels/FeedbackLabel.vue'
import { FeedbackLabels as Labels } from '@/store/modules/feedback-labels'
import LabelSelector from '@/components/feedback_labels/LabelSelector.vue'
import SubmissionLine from '@/components/submission_notes/base/SubmissionLine'
import { SubmissionNotes, subNotesEventBus } from '@/store/modules/submission-notes'
import { SubmissionType } from '@/models'
import { Authentication } from '@/store/modules/authentication'
import { actions } from '@/store/actions'
import { fetchFeedback } from '@/api'
import MathRenderer from '@/components/MathRenderer.vue'

export default {
  name: 'SubmissionCorrection',
  components: {
    SubmissionLine,
    BaseAnnotatedSubmission,
    AnnotatedSubmissionBottomToolbar,
    AnnotatedSubmissionTopToolbar,
    FeedbackComment,
    LabelSelector,
    CommentForm,
    MathRenderer },
  props: {
    assignment: {
      default: () => {},
      type: Object
    },
    // either pass in an assignment or a submission and feedback
    submissionWithoutAssignment: {
      default: () => {},
      type: Object
    },
    feedback: {
      default: () => {},
      type: Object
    },
    ignoreHiddenState: {
      type: Boolean,
      default: false,
    }
  },
  data () {
    return {
      loading: false,
      feedbackShortPollInterval: null,
      mathIsRendered: true,
    }
  },
  computed: {
    showEditorOnLine () { return SubmissionNotes.state.ui.showEditorOnLine },
    selectedComment () { return SubmissionNotes.state.ui.selectedCommentOnLine },
    origFeedback () { return SubmissionNotes.state.origFeedback.feedbackLines },
    updatedFeedback () { return SubmissionNotes.state.updatedFeedback.feedbackLines },
    showFeedback () { return SubmissionNotes.state.ui.showFeedback },

    workInProgress () { return SubmissionNotes.workInProgress },

    sourceCodeAvailable () {
      return SubmissionNotes.state.submission.sourceCodeAvailable
    },

    isStudent () { return Authentication.isStudent },
    isTutor () { return Authentication.isTutor },
    isReviewer () { return Authentication.isReviewer },
    user () { return Authentication.state.user.username },
    submission () {
      return SubmissionNotes.submission
    },
    isMarkdown () {
      const lang = SubmissionNotes.submissionType.programmingLanguage
      return lang === SubmissionType.ProgrammingLanguageEnum.Markdown
    },
    submissionObj () {
      return this.assignment ? this.assignment.submission : this.submissionWithoutAssignment
    },
    feedbackObj () {
      return this.assignment ? this.assignment.feedback : this.feedback
    }
  },
  watch: {
    assignment: function (newVar, oldVar) {
      this.init()
    },
    submissionWithoutAssignment: function () {
      this.init()
    },
    submission: function (oldVal, newVal) {
      if (JSON.stringify(oldVal) !== JSON.stringify(newVal)) {
        subNotesEventBus.$emit('submissionChanged')
      }
    }
  },
  created () {
    this.init()
    this.shortPollOrigFeedback()
  },
  beforeDestroy () {
    clearInterval(this.feedbackShortPollInterval)
  },
  methods: {
    toggleEditorOnLine (lineNo, comment = '') {
      SubmissionNotes.TOGGLE_EDITOR_ON_LINE({ lineNo, comment })
    },
    submitFeedback ({ isFinal }) {
      this.loading = true
      SubmissionNotes.submitFeedback({
        isFinal: isFinal
      }).then(_ => {
        SubmissionNotes.RESET_UPDATED_FEEDBACK()
        this.$emit('feedbackCreated')
        this.$emit('feedbackChanged')
        SubmissionNotes.RESET_MARKED_COMMENTS_FOR_DELETE()
      }).catch(err => {
        // ignore trivial errors as those are handled
        // by an interceptor
        if (err.message.includes('Request failed')) return

        this.$notify({
          title: 'Feedback creation Error!',
          text: err.message,
          type: 'error',
          duration: -1
        })
      }).finally(() => {
        this.loading = false
      })
    },
    shortPollOrigFeedback () {
      this.feedbackShortPollInterval = setInterval(() => {
        if (this.feedbackObj && this.feedbackObj.ofSubmission) {
          fetchFeedback({ ofSubmission: this.feedbackObj.ofSubmission }).then(feedback => {
            SubmissionNotes.SET_ORIG_FEEDBACK(feedback)
          })
        }
      }, 5e3)
    },
    getSortedComments (lineNo) {
      if (!this.origFeedback || (!this.origFeedback && !this.origFeedback[lineNo])) return new Array()
      let feedback = [...this.origFeedback[lineNo]]

      return feedback.sort((a, b) => {
        const da = new Date(a.modified)
        const db = new Date(b.modified)
        return da.getTime() - db.getTime()
      })
    },
    hasHiddenComment (lineNo) {
      const hasOrigComment = this.origFeedback && this.origFeedback[lineNo]
        && this.origFeedback[lineNo].length > 0

      const hasUpdatedComment = this.updatedFeedback && this.updatedFeedback[lineNo]

      return !this.showFeedback && (hasOrigComment || !!hasUpdatedComment)
    },
    init () {
      SubmissionNotes.RESET_STATE()
      SubmissionNotes.SET_SUBMISSION(this.submissionObj)
      SubmissionNotes.SET_ORIG_FEEDBACK(this.feedbackObj)
      SubmissionNotes.SET_SHOW_FEEDBACK(this.ignoreHiddenState ? true : !SubmissionNotes.state.hasOrigFeedback)
    }
  }
}
</script>

<style scoped>

</style>
